<!--
 - Created by MarosGrajcar on 10/28/2019.
 -->

<!-- Elg Task Search -->
<template>

     <div class="slds-grid slds-wrap slds-card slds-p-around--small">
         <span class="slds-size--6-of-12">
             <lightning-icon icon-name="standard:task"></lightning-icon>
             <span class="slds-text-title_caps slds-p-left--x-small">
                 Search Tasks
             </span>
         </span>

         <span class="slds-size--6-of-12 slds-text-align--right slds-p-left--x-small">
             <lightning-button variant="success"
                               label="Open Selected Tasks"
                               onclick={openSelectedTasks}>
             </lightning-button>
         </span>

     </div>

    <div class="slds-grid slds-wrap">

        <div class="slds-col slds-size_2-of-12 slds-p-around_x-small">
            <div class="slds-section slds-is-open slds-card slds-card_boundary">
                <div class="slds-m-around--small">
                    <c-elg_amu_lookup label="AMU"
                                      object-a-p-i-name="Field__c"
                                      amu-ids={postAMUs}
                                      placeholder="Choose AMU"
                                      render-icon="true"
                                      pre-selected-record={selectedAMU}
                                      onclearselection={clearAMU}
                                      onselection={handleAMU}>
                    </c-elg_amu_lookup>

                    <template if:true={showFilter}>
                        <div class="slds-m-top--small">

                            <lightning-combobox
                                    name="status"
                                    label="POST"
                                    placeholder="Choose Post"
                                    value={selectedPost}
                                    onchange={handleSelectedPost}
                                    options={thermalPosts}>
                            </lightning-combobox>

                            <span if:true={postIsSelected} class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearPostSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>


                        <div class="slds-m-top--small">
                            <lightning-combobox
                                    name="status"
                                    label="TASK STATUS"
                                    placeholder="Choose Task Status"
                                    value={selectedTaskStatus}
                                    onchange={handleSelectedTaskStatus}
                                    options={taskStatuses}>
                            </lightning-combobox>

                            <span if:true={statusIsSelected} class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearStatusSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>
                        </div>

                        <div class="slds-m-top--medium">
                            <lightning-input type="date"
                                             label="START DATE"
                                             placeholder="Choose Start Date"
                                             autocomplete="off"
                                             value={startDate}
                                             onchange={handleSelectedStartDate}>
                            </lightning-input>

                            <span if:true={startDateIsSelected}
                                  class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearStartDate}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>

                        <div class="slds-m-top--small">
                            <lightning-input type="date"
                                             label="END DATE"
                                             placeholder="Choose End Date"
                                             autocomplete="off"
                                             value={endDate}
                                             onchange={handleSelectedEndDate}>
                            </lightning-input>

                            <span if:true={endDateIsSelected}
                                  class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearEndDate}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>

                        <div class="slds-m-top--medium">
                            <lightning-input label="Change default sort" type="checkbox" checked={checked}
                                             onchange={handleCheckboxChange}></lightning-input>
                        </div>

                        <div if:true={userSort} class="slds-m-top--medium">
                            <lightning-combobox
                                    name="sortBy"
                                    label="SORT BY FIELD"
                                    placeholder="Choose Field To Sort By"
                                    value={sortByField}
                                    onchange={handleSortByField}
                                    options={sortByFieldOptions}>
                            </lightning-combobox>
                            <div class="slds-m-top--medium">
                                <lightning-combobox
                                        name="sortingOrder"
                                        label="DIRECTION"
                                        placeholder="Choose Sorting Direction"
                                        value={sortingDirection}
                                        onchange={handleSortingDirection}
                                        options={sortByDirection}>
                                </lightning-combobox>
                            </div>
                        </div>

                    </template>
                </div>


                <div if:true={showFilter} class="slds-m-around--medium">
                    <template if:true={showSpinner}>
                        <lightning-spinner alternative-text="Loading"></lightning-spinner>
                    </template>
                    <lightning-button variant="neutral" label="Clear Selection"
                                      onclick={clearData}></lightning-button>
                    <lightning-button variant="brand" label="Search"
                                      onclick={availableTasks}></lightning-button>
                </div>

            </div>
        </div>

        <div if:false={showError} class="slds-col slds-size_10-of-12 slds-p-around_x-small">

            <div if:true={defaultView} class="slds-section slds-is-open slds-card slds-card_boundary">
                <template if:true={showSpinner}>
                    <lightning-spinner alternative-text="Loading"></lightning-spinner>
                </template>

                <lightning-datatable
                        key-field="id"
                        data={tasks}
                        columns={taskColumns}>
                </lightning-datatable>

            </div>

            <div if:true={completedView} class="slds-section slds-is-open slds-card slds-card_boundary">
                <template if:true={showSpinner}>
                    <lightning-spinner alternative-text="Loading"></lightning-spinner>
                </template>

                <lightning-datatable
                        key-field="id"
                        data={tasks}
                        columns={completedTasksColumns}>
                </lightning-datatable>

            </div>

            <div if:true={cancelledView} class="slds-section slds-is-open slds-card slds-card_boundary">
                <template if:true={showSpinner}>
                    <lightning-spinner alternative-text="Loading"></lightning-spinner>
                </template>

                <lightning-datatable
                        key-field="id"
                        data={tasks}
                        columns={cancelledTasksColumns}>
                </lightning-datatable>

            </div>


            <div if:true={tasks}>

                <div class="slds-m-vertical_medium content">Total records: <b>{totalRecords} </b>
                    <span if:false={singlePage}>
                        Page <b> {currentPage}</b> of <b> {totalPages}</b>
                    </span>
                </div>

                <!--Pagination section later in standalone component-->
                <span if:false={singlePage}>

                <lightning-layout>
                    <lightning-layout-item>
                        <lightning-button label="First" icon-name="utility:chevronleft" onclick={handleFirst}
                                          disabled={showFirstButton}></lightning-button>
                    </lightning-layout-item>
                    <lightning-layout-item>
                        <lightning-button label="Previous" icon-name="utility:chevronleft" onclick={handlePrevious}
                                          disabled={showFirstButton}></lightning-button>
                    </lightning-layout-item>
                    <lightning-layout-item flexibility="grow"></lightning-layout-item>
                    <lightning-layout-item>
                        <lightning-button label="Next" icon-name="utility:chevronright" icon-position="right"
                                          onclick={handleNext}
                                          disabled={showLastButton}></lightning-button>
                    </lightning-layout-item>
                    <lightning-layout-item>
                        <lightning-button label="Last" icon-name="utility:chevronright" icon-position="right"
                                          onclick={handleLast}
                                          disabled={showLastButton}></lightning-button>
                    </lightning-layout-item>
                </lightning-layout>

                </span>

            </div>


        </div>

        <div if:true={showError} class="slds-col slds-size_10-of-12 slds-p-around_x-small">
            <div class="slds-section slds-is-open slds-card slds-card_boundary slds-align--absolute-center slds-text-title_caps slds-p-around_small">
                <b>{errorMessage}</b>
            </div>
        </div>

    </div>


</template>